package collio;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public class Main {

  public static void main(String[] args) throws Exception {
    String ifName = "szamok.txt";
    String ofName = "szamok_ki.txt";
    
    // tarolo a beolvasott szamoknak
    List<Racionalis> list = null;
    try {
      list = readList(ifName);
    } catch (FileNotFoundException e) {
      System.out.println("Nem jo file nevet adtal meg: " + e);
      System.exit(1);
    } catch (Exception e) {
      System.out.println("Valami mas Exception: " + e);
      System.exit(1);
    }
    
    // itt mar nem lehet a list null
    System.out.println(list);
    
    // iterator 1
    for (Racionalis r : list) {
      System.out.print(r + "\t");
    }
    System.out.println();
    
    // iteration 2
    Iterator<Racionalis> it = list.iterator();
    while (it.hasNext()) {
      System.out.print(it.next() + "\t");
    }
    System.out.println();
    
    // irjuk ki a tizedes tort alakokat
    writeList(ofName, list);
  }
  
  public static List<Racionalis> readList(String fileName) throws Exception {
    // lista az eredmenyeknek
    List<Racionalis> list = new LinkedList<Racionalis>();
    // file megnyitasa
    BufferedReader br = new BufferedReader(new FileReader(fileName));
    // tarolo a file egy sorahoz
    String line;
    // olvassuk a filet soronkent, amig a vegere nem erunk
    while ((line = br.readLine()) != null) {
      // vagjuk szet a sort whitespace-enkent
      String[] split = line.split("\\s");
      // hozzuk letre a racionalis szam objektumot
      double szamlalo = Double.parseDouble(split[0]);
      double nevezo = Double.parseDouble(split[1]);
      Racionalis szam = new Racionalis(szamlalo, nevezo);
      // taroljuk el a listaban
      list.add(szam);
    }
    // file bezatasa
    br.close();
    // adjuk vissza a beolvasott szamok listajat
    return list;
  }
  
  public static void writeList(String fileName, List<Racionalis> list) throws Exception {
    // nyissuk meg a filet irasra
    //PrintWriter pw = new PrintWriter(fileName);
    PrintWriter pw = new PrintWriter(new FileWriter(fileName, false));
    for (Racionalis r : list) {
      try {
        // elkerjuk az erteket, ha exception dobodik, a vezerles
        // atugrik a catch agra (nem lesz kiirva a szam).
        double value = r.getValue();
        // beleirjuk az erteket a fileba
        pw.println(r + ": " + value);
      } catch (MyException e) {
        System.out.println("A " + r + " szam nem racionalis! Nem lesz kiirva: " + e);
      }
    }
    // zarjuk le a filet
    pw.close();
  }

}
