package collio;

public class Racionalis {
  private final double szamlalo;
  private final double nevezo;
  
  public Racionalis(double sz, double n) {
    szamlalo = sz;
    nevezo = n;
  }

  public double getSzamlalo() {
    return szamlalo;
  }

  public double getNevezo() {
    return nevezo;
  }
  
  /**
   * Visszaadja a racionalis szam tizedes tort alakjat.
   * @return tizedes tort alak
   * @throws MyException nullaval valo osztas eseten
   */
  public double getValue() throws MyException {
    if (nevezo == 0.0) {
      throw new MyException("Nullaval osztas");
    }
    return szamlalo/nevezo;
  }
  
  public String toString() {
    return szamlalo + "/" + nevezo;
  }
  
}
